<script>
    import { area, line } from 'd3';
    export let plotElement;
    export let data;
    export let xScale;
    export let yScale;

    $: multiplier = plotElement["parameter_multiplier"] ? plotElement["parameter_multiplier"] : 1.0;
    const areaFunction = function(data, xScale, yScale, parameter) {
        // console.log(plotElement, data);
        return area()
            .defined(d => {
                if (plotElement.baseline_parameter) {
                    return !(isNaN(d[parameter]) || isNaN(d[plotElement.baseline_parameter]))
                } else {
                    return !isNaN(d[parameter])
                }
            })
            .x(d => xScale(d.time))
            .y0(d => {
                if (isNaN(d[parameter])){
                    return NaN;
                } else {
                    if (plotElement.plot_options.mirror_zero_x) {
                        return yScale(-1*d[parameter]*multiplier);
                    } else if (plotElement.baseline_y_value) {
                        return yScale(plotElement.baseline_y_value);
                    } else if (plotElement.baseline_parameter) {
                        if (isNaN(d[plotElement.baseline_parameter])) {
                            return NaN;
                        }
                        return yScale(d[plotElement.baseline_parameter]);
                    } else {
                        return yScale(1e-20);
                    }
                }
            })
            .y1(d => yScale(d[parameter]*multiplier))(data);
    }

    // We draw the stroke of the area as a separate path, so that data gaps
    // do not display with a stroke going towards y=0.
    let lineFunction = undefined;
    let lineFunctionMirror = undefined;
    if (plotElement.plot_options['stroke'] != 'none') {
        lineFunction = function(data, xScale, yScale, parameter) {
                return line()
                    .defined(d => !isNaN(d[parameter]))
                    .x((d) => xScale(d.time))
                    .y((d) => yScale(d[parameter]*multiplier))(data)
        }
        if (plotElement.plot_options.mirror_zero_x) {
            lineFunctionMirror = function(data, xScale, yScale, parameter) {
            return line()
                .defined(d => !isNaN(d[parameter]))
                .x((d) => xScale(d.time))
                .y((d) => yScale(-1*d[parameter]*multiplier))(data)
            }
        }
    }
</script>

{#await data}
{:then datapoints}
{#if datapoints}
    <!-- <text x={xScale(datapoints[Math.floor(datapoints.length/2)]['time'])}
          y={yScale(datapoints[Math.floor(datapoints.length/2)][plotElement.parameter])}
          text-anchor="middle"
          dominant-baseline="middle"
          style="font-size: 10px; fill: {plotElement.plot_options['fill']};">
          {plotElement.parameter}
    </text> -->
    <path d={areaFunction(datapoints,xScale,yScale,plotElement.parameter)}
          fill={plotElement.plot_options['fill']}
          fill-opacity={plotElement.plot_options['fill-opacity']}/>

    {#if lineFunction}
        <path d={lineFunction(datapoints,xScale,yScale,plotElement.parameter)}
              stroke={plotElement.plot_options['stroke']}
              stroke-width={plotElement.plot_options['stroke-width']}
              stroke-opacity={plotElement.plot_options['stroke-opacity']}
              fill="none"/>
    {/if}
    {#if lineFunctionMirror}
        <path d={lineFunctionMirror(datapoints,xScale,yScale,plotElement.parameter)}
              stroke={plotElement.plot_options['stroke']}
              stroke-width={plotElement.plot_options['stroke-width']}
              stroke-opacity={plotElement.plot_options['stroke-opacity']}
              fill="none"/>
    {/if}

{/if}
{/await}
<style>

</style>
